import common
import socket
import sys

##############################################################################

class GameClient(object):

    def __init__(self, name, server_address, server_port):
        self.port = server_port
        self.server_address = server_address
        self.name = name

    def connect_to_server(self):
        s = socket.socket(socket.AF_INET,
                          socket.SOCK_STREAM)
        s.connect((self.server_address, self.port))
        self.socket = common.CommSocket(s)

    def send_name(self):
        print "Receiving request"
        r = self.socket.recv_object()
        assert r == common.REQUEST_INFO
        self.socket.send_object(self.name)

    def play_game(self):
        self.connect_to_server()
        self.send_name()

        starting_state = self.socket.recv_object()
        self.starting_state(starting_state)

        while 1:
            r = self.socket.recv_object()
            this_state = self.socket.recv_object()
            if r == common.REQUEST_PLAY:
                response = self.play_turn(this_state)
                assert (response == common.RESPONSE_TAKE or
                        response == common.RESPONSE_PASS)
                self.socket.send_object(response)                
            elif r == common.NOTIFY_GAMEOVER:
                self.game_over(this_state)
                self.socket.send_object(common.ACK_GAMEOVER)
                break
            else:
                raise Exception("Bogus send from server")

    def starting_state(self, state):
        pass

    def play_turn(self, current_state):
        pass

    def game_over(self, current_state):
        pass
        

##############################################################################
